#include "fourni.h"

void afficher( short* img, int m, int n ) {
    int i, j;
    for( i = 0 ; i < m ; i++ ) {
        for( j = 0 ; j < n ; j++ ) {
            if( 0 == img[ i * n + j ] ) {
                printf( " " );
            } else {
                printf( "X" );
            }
            printf( " " );
        }
        printf( "\n" );
    }
}

short* init( int m, int n, float densite ) {

    short* espace;
    int i;
    float nb;

    espace = (short*) malloc( m * n * sizeof( short* ) );
    memset( espace, 0, m * n * sizeof( short ) );

    for( i = 0 ; i < m * n ; i++ ) {
        nb = (float) rand() / ((float)RAND_MAX + 1.0);
        if( nb < __DENSITE__ ) {
            espace[i] = 1;
        } else {
            espace[i] = 0;
        }
    }
    return espace;
}

void jeuDeLaVie( short* tab, short* tmp, int m, int n ) {

    int i, j;
    int nb_voisines;

    for( i = 0 ; i < m ; i++ ) {
        for( j = 0 ; j < n ; j++ ) {

            /* on compte ses voisines */

            nb_voisines = 0;
            if( i > 0 ) {             /* Voisines du dessus */
                nb_voisines += tab[ ( i - 1 ) * n + j ];
                if( j > 0 ) {
                    nb_voisines += tab[ ( i - 1 ) * n + j - 1 ];
                }
                if( j < n - 1 ) { 
                    nb_voisines += tab[ ( i - 1 ) * n + j + 1 ];
                }
            }
            if( i < m - 1 ) {         /* Voisines du dessous */
                nb_voisines += tab[ ( i + 1 ) * n + j ];
                if( j > 0 ) {
                    nb_voisines += tab[ ( i + 1 ) * n + j - 1 ];
                }
                if( j < n - 1 ) { 
                    nb_voisines += tab[ ( i + 1 ) * n + j + 1 ];
                }
            }
            if( j > 0 ) {             /* Côtés */
                nb_voisines += tab[ i * n + j - 1 ];
            }
            if( j < n - 1 ) {
                nb_voisines += tab[ i * n + j + 1 ];
            }

            /* Si on a trop de voisines, on meurt */

            if( nb_voisines > 3 ) {
                tmp[ i * n + j ] = 0;
            }

            /* Si on en a 2 ou 3, on nait */

            if( nb_voisines == 3 || nb_voisines == 2 ) {
                tmp[ i * n + j ] = 1;
            }

            /* Si on n'a qu'une voisine ou aucune, on meurt */

            if( nb_voisines < 2 ) {
                tmp[ i * n + j ] = 0;
            }
        }
    }

    memcpy( tab, tmp, m * n * sizeof( short ) );

}
